      subroutine tau_dummy_grid(nx,ny,grid)
C+-----------------------------------------------------------------------------
C
C   ---------------------------
C   T A U _ D U M M Y _ G R I D
C   ---------------------------
C
C   Description
C   -----------
C   Creates a dummy grid if none where created in MASK and GRID.
C
C
C   Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
C
C   (>) NX:         (integer) X dimension of obs cube.
C   (>) NY:         (integer) Y dimension of obs cube.
C   (<) GRID:       (real array (GRID(NX,NY)) Output dummy grid.
C
C
C   Prompts
C   -------
C   None
C
C
C   External functions & subroutines called
C   ---------------------------------------
C   None
C
C   INCLUDE statements
C   ------------------
C   None
C                                                
C
C   Extensions to FORTRAN77
C   -----------------------
C   IMPLICIT NONE / END DO / Names > 6 characters
C
C
C   SUN-specific statements
C   -----------------------
C   None.
C
C
C   Author/s
C   --------
C   Jim Lewis    RGO  (jrl@uk.ac.cam.ast.mail)
C
C
C   History
C   -------
C   19-MAR-1990   - Original subroutine
C
C
C+-----------------------------------------------------------------------------
      implicit none
C
C     Parameters
C
      integer nx,ny
      real grid(2,nx,ny)
C
C     Local variables
C
      integer i,j
      real y
C
C     Create the grid...
C
      do j = 1,ny
         y = float(j)
         do i = 1,nx
            grid(1,i,j) = float(i)
            grid(2,i,j) = y
         end do
      end do
      end
