      subroutine ccd
      implicit none
C
C     Local variables
C
      integer status,ndim,dims(10),nelm,nx,ny,address,
     : optr,slot2,iptr,slot1,nz
      character type*10
      logical badpix
C
C     Functions
C
      integer dyn_element
C
C     Dynamic memory
C
      include 'dyn_source:dynamic_memory.inc'
C
C     Start up the ol' DSA
C
      status = 0
      call dsa_open(status)
      if (status .ne. 0) go to 500
C
C     Open input file
C
      call dsa_input('input','input',status)
      call ndp_get_image_info('input',.true.,.false.,type,badpix,
     : status)
      call dsa_data_size ('input',3,ndim,dims,nelm,status)
      if (status.ne.0) goto 500
      if ((ndim .ne. 3) .and. (ndim .ne. 2)) then
         call dsa_wruser('Data is not 2 or 3-dimensional\n')
         go to 500
      end if
      nx = dims(1)
      ny = dims(2)
      if (ndim .eq. 2) then
         nz = 1
      else
         nz = dims(3)
      end if
C
C     Map input file
C
      call dsa_map_data('input','read','short',address,slot1,status)
      if (status .ne. 0) go to 500
      iptr = dyn_element(address)
C
C     Open output file
C
      call dsa_output('output','output','input',0,1,status)
      if (status .ne. 0) go to 500
C
C     Map output file as float
C
      call dsa_coerce_data_array('output','float',ndim,dims,status)
      call dsa_map_data('output','write','float',address,slot2,status)
      if (status .ne. 0) go to 500
      optr = dyn_element(address)
C
C     Right, fix it all up...
C
      call sub_ccd(nx,ny,nz,dynamic_mem(iptr),dynamic_mem(optr))
C
C     Tidy and exit
C
  500 call dsa_close(status)
      end


      subroutine sub_ccd(nx,ny,nz,input,output)
      implicit none
C
C     Parameters
C
      integer nx,ny,nz
      integer*2 input(nx,ny,nz)
      real output(nx,ny,nz)
C
C     Local variables
C
      integer i,j,k
      real factor
C
C     Extra factor to add in
C
      factor = 65536.0
C
C     Now fix it
C
      do k = 1,nz
         do j = 1,ny
            do i = 1,nx
               if (input(i,j,k) .lt. 0) then
                  output(i,j,k) = float(input(i,j,k)) + factor
               else 
                  output(i,j,k) = float(input(i,j,k))
               end if
            end do
         end do
      end do
      end            
